int fullHours;
int fullMinutes;
int manFullHours;
int fullSeconds;
int dayColor;
int maxDistSize;
int bigFlash;

int[] histB = new int[255]; 

Random generator;


float arcScale;
LineText hText, mText, sText;
TimeArc sArc, mArc, hArc;

ArrayList pgDistortions;

PGraphics full;

PImage bgPicture;

void setup() {
  generator = new Random();
  size(800, 800);
  frameRate(30);
  maxDistSize = 100;
  full = createGraphics(width+2*maxDistSize, height+2*maxDistSize, P2D);
  //println(full.height);
  bgPicture = loadImage("background.jpg");

  bigFlash = 0;

  sArc = new TimeArc(full);
  mArc = new TimeArc(full);
  hArc = new TimeArc(full);
  arcScale = 1;

  //background(255);
  smooth();
  full.smooth();
  pgDistortions = new ArrayList();
  for (int i=0;i<30;i++)
  {
    pgDistortions.add(new Distort(200, 10, 2, false)); // width,height,peak,line?
  }
  for (int i=0;i<10;i++)
  {
    pgDistortions.add(new Distort(200, 100, 20, false)); // width,height,peak,line?
  }
  for (int i = 0;i<5;i++)
  {
    pgDistortions.add(new Distort(width, int(random(5, 50)), int(random(5, 40)), true)); // width,height,peak,line?
  }
}

void draw() {
  full.colorMode(RGB, 255);
  full.beginDraw();
  full.image(bgPicture, 0, 0, full.width, full.height);

  full.noFill();
  noCursor();


  clock(mouseX+maxDistSize/2, mouseY+maxDistSize/2);
}


void clock(int xWert, int yWert) {


  arcScale = map(yWert, 0, height, 3, 5)+random(0.1);
  full.noStroke();
  colorMode(HSB, 360);

  fullHours = (hour()*3600+minute()*60+second())*360/86400;
  fullMinutes = (minute()*60+second())*360/3600;
  fullSeconds = (second())*360/60;

  full.pushMatrix();
  full.translate(xWert, yWert);
  full.rotate(-PI/2);
  manFullHours = fullHours;
  if (manFullHours < 43200*360/86400) // 0 -12:00 Uhr
  {
    dayColor= int(map(manFullHours, 0, 180, -120, 60));
    //println("0:00-12:00");
  } 

  else 
  {
    dayColor= int(map(manFullHours, 180, 359, 60, -120));
    //println("12:00-0:00");
  }


  if ( dayColor < 0)
  {
    dayColor = 360 + dayColor;
  }
  //println(dayColor);


  dayColor = 240;


  hArc.update(color(dayColor, 60, 180), 40, 2*fullHours, fullHours*24/360, arcScale);
  hArc.draw();

  mArc.update(color(dayColor, 240, 200), 30, fullMinutes, fullMinutes*60/360, arcScale);
  mArc.draw();

  sArc.update(color(dayColor, 360, 200), 20, fullSeconds, fullSeconds*60/360, arcScale);
  sArc.draw();
  full.popMatrix();
  
  loadPixels();
  
  


  full.endDraw();
  updatePixels();
  
  pNoise();
  television();
  
  image(full, -maxDistSize/2, -maxDistSize/2);
  for (int i = 0; i < pgDistortions.size(); i++)
  {
    Distort distortion = (Distort) pgDistortions.get(i); 
    distortion.draw();
  }
  
  
  if (bigFlash <= 1)
  {

    //full.background(360);

    filter(ERODE);
    if (bigFlash == 0)
    {
      bigFlash = int(random(10, 80));
    }
  }
  bigFlash--;
  
  histogram();
}


void pNoise()
{
  loadPixels();

  for ( int x = 0; x < full.width; x++)
  {
    for (int y = 0; y < full.height; y++)
    { 
      int loc = x + y * full.width; 
      colorMode(RGB, 255);
      color col = full.pixels[loc];


      //noise
      int dColor = int(random(-50, 50));
      full.pixels[loc] = color(red(col)+dColor, green(col)+dColor, blue(col)+dColor, 100);
    }
  }

  updatePixels();
}


void television()
{
  loadPixels();

  for ( int x = 0; x < full.width; x++)
  {
    for (int y = 0; y < full.height; y++)
    { 
      if (y % 4 == 0)
      {
        int loc = x + y * full.width; 
        colorMode(RGB, 255);
        color col = full.pixels[loc];


        //noise
        full.pixels[loc] = color(red(col)-50, green(col)-50, blue(col)-50);
      }
    }
  }

  updatePixels();
}

float randomNormal()
{
  float x = 1.0, y = 1.0, 
  s = 2.0; // s = x^2 + y^2
  while (s >= 1.0)
  {
    x = random(-1.0f, 1.0f);
    y = random(-1.0f, 1.0f);
    s = x*x + y*y;
  }
  return x * sqrt(-2.0f * log(s)/s);
}

void histogram(){
  for (int x=0; x<width; x++)
  {
    for (int y=0; y<height; y++)
    {
      int bright = int(brightness(get(x,y)));
      histB[bright]++;
      
      
    }
  }
  
  int histMax = max(histB);
  
  stroke(0);
  
  for (int i = 0; i < width; i+=2)
  {
    int wich = int(map(i, 0, width, 0, 255));

    int y = int(map(histB[wich],0,histMax, height,0));
    
    line(i, height, i, y);
  }
  
  
}

