class LineText {
  color c;
  float lineStart,lineLength, pScale, arcWeight; 
  float arcValue, oldArcValue, saveArcValue; // Winkel
  int lText, oldLText, saveText, textCounter;
  PFont font;

  LineText() {
    c = color(255, 255, 255);
    lineLength = 0;
    arcValue = 0;
    lText = 0;
  }

  LineText(color _c, float _lineStart, float _lineLength, float _arcValue, int _lText, float _pScale, int _arcWeight) {  

    c = _c;
    lineLength = _lineLength;
    lineStart = _lineStart;
    arcWeight = _arcWeight;
    arcValue = _arcValue;
    lText = _lText;
    pScale = _pScale;
    oldLText = lText;
    oldArcValue = arcValue;
    saveText = lText;
    saveArcValue = arcValue;
    textCounter = 1000;
  }

  void draw()
  {
    font = loadFont("FrutigerLTCom-Light-48.vlw");
    full.textFont(font, 12*pScale);
    full.pushMatrix();
    full.rotate(arcValue);
    full.strokeWeight(1*pScale);
    full.stroke(c);
    full.line(lineStart*pScale-arcWeight/2, 0, (lineLength+45)*pScale, 0);
    full.fill(c);
    full.textAlign(RIGHT);
    full.text(lText, (lineLength+45)*pScale, -4);
    full.popMatrix();

    if (oldLText != lText)
    {
      saveText= lText;
      saveArcValue = arcValue; 
      textCounter= 0;
    }
    


    if(textCounter<= 10)
    {
    font = loadFont("FrutigerLTCom-Light-48.vlw");
  
    full.textFont(font, 12*pScale*(1+textCounter*0.1*pScale));
    //println(textCounter);
    full.pushMatrix();
    
    full.rotate(saveArcValue);
    full.translate(textCounter*0.2*12*pScale,textCounter*0.2*pScale*12);
    full.fill(c,map(textCounter,0,10,200,0));
    full.text(saveText, (lineLength+45)*pScale+random(-2,2), -4+random(-2,2));

    textCounter++;
    oldLText = lText;
    oldArcValue = arcValue;
    full.popMatrix();
    }
  }

  void update(color _c, float _lineStart, float _lineLength, float _arcValue, int _lText, float _pScale, int _arcWeight) {

    c = _c;
    pScale = _pScale;
    lineLength = _lineLength;
    lineStart = _lineStart;
    arcWeight = _arcWeight;
    arcValue = _arcValue;
    lText = _lText;
    font = loadFont("DIN-Light-12.vlw");
    full.textFont(font, 12*pScale);
  }
}

